

function [x1_ptos, x2_ptos, x1_opt, x2_opt]=switching_curves_comp_func(c, w, bo, alpha, xl, Xo)
%% parameters for PTOS switching

T=1;



% %saturator limit
% %slopes for the linearized region
k1=(c-xl)/(c*xl); 
k2=sqrt(2*c*alpha*xl-alpha*xl^2)/(alpha*w*c*xl);
% 
% 
% 
% %%n is essentially how many ellipses to draw
% 
% n  = abs(ceil(Xo(1)/(c)))+4;
n  = abs(ceil(Xo(1)/(c)));

%%%% added a whole bunch of code to make sure the plot goes to the x_2
%%%% axis.

% make a vector with all the intervals of 2c
for i=-n:n;
    ns(i+n+1) = 2*c*i;
    
end
% ns

x1_opt=0;
dfx=.001;

for i=1:length(ns)-1
    if (length(x1_opt)>2 & i ~= (length(ns)-1))
        x1_opt=[x1_opt, ns(i):dfx:(ns(i+1)-dfx)];
    elseif(i ~= (length(ns)-1))
        x1_opt=[ns(i):dfx:(ns(i+1)-dfx)];
    else
        x1_opt=[x1_opt, ns(i):dfx:(ns(i+1))];
    end
end

% 
% %%since i want to plot x1 on x axis, x2 on y axis, i need to generate a set
% %%of points from which to build x2
% x1_opt=[-n*c:.001:n*c];




% % x1_bar=zeros(1,length(x1_opt));
% % x2_opt=zeros(1,length(x1_opt));
% 
% %%this calculates x1_bar from a modified version pg 7. I think the signs
% %%were wrong on that page, at the very least, the signs as given dont
% %%produce the graph shown. FYI, fracpart is my own matlab function to
% %%produce the fractional part of a number.
for i=1:length(x1_opt);
    if (mod(sign(x1_opt(i)/c)*floor(abs(x1_opt(i)/c)), 2)==0);
        x1_bar(i)=c-abs(fracpart(x1_opt(i)/c)*c);
    else
        x1_bar(i)=fracpart(x1_opt(i)/c)*c;
    end
    
end
% 
% %%now we c start producing curves. the following, commented out code
% %%produces the simple time optimal switching curve shown on page 9, fig 2.
for i=1:length(x1_opt);
   x2_opt(i)=-sign(x1_opt(i))*(bo/w)*sqrt(1-(w^4)*(x1_bar(i))^2/(bo^2));
    %x2(i)=(bo^2/w^2)*sqrt(1-(w^4)*(x1_bar(i))^2/(bo^2));
end
% 
x1_ptos=[-2*c:.01:2*c];

for i=1:length(x1_ptos)
    if( abs(x1_ptos(i))>= xl )

        x2_ptos(i)= -sign(x1_ptos(i)) *( w*sqrt(alpha*2*c*abs(x1_ptos(i)) -alpha*x1_ptos(i)^2) -1/k2);
    %     GEE='yes'
    %     control=-sat( k2*(Fptos +u(2)), T);
     elseif(abs(x1_ptos(i)) < xl )
         x2_ptos(i)=-(k1/k2)*x1_ptos(i);
    %       control=sat(-k1*u(1) -k2*u(2), T );
%             control=-sat( k2*(Fptos +u(2)), T);

    end
end

end